﻿function randomPassword(length, value) {
    var chars = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890!£$%^&*()-=_+#~][{};:@,./?";
    var pass = "";
    for (var i = 0; i < length; i++) {
        var index = Math.floor(Math.random() * 88);
        pass += chars.charAt(index);
    }
    value.value = pass;
};

function EncryptData(thedata, key) {
    var encoded = GibberishAES.enc(thedata, key);
    encoded = encoded.replace(/\n/g, '');

    return encoded;
}

function post_to_url(path, params, method) {
    method = method || "post";

    var form = document.createElement("form");
    form.setAttribute("method", method);
    form.setAttribute("action", path);

    for (var key in params) {
        if (params.hasOwnProperty(key)) {
            var hiddenField = document.createElement("input");
            hiddenField.setAttribute("type", "hidden");
            hiddenField.setAttribute("name", key);
            hiddenField.setAttribute("value", params[key]);

            form.appendChild(hiddenField);
        }
    }

    document.body.appendChild(form);
    form.submit();
}

function ValidateInput(title, description, bitcoinaddress, passphrase, repeatpassphrase, publickey) {
    if (title.length < 101 && title.length > 1 && description.length < 1001 && description.length > 1 && bitcoinaddress.length < 35 && bitcoinaddress.length > 26 && passphrase.length == 32 && repeatpassphrase.length == 32 && publickey.length < 5001)
        return true;
    else
        return false;
}

function ValidateNoHTML(title, description, bitcoinaddress, passphrase, repeatpassphrase, publickey) {
    if (QuickHTMLCheck(title) || QuickHTMLCheck(description) || QuickHTMLCheck(bitcoinaddress) || QuickHTMLCheck(passphrase) || QuickHTMLCheck(repeatpassphrase) || QuickHTMLCheck(publickey))
        return false;
    else
        return true;
}

function ValidatePassphrases(passphrase, repeatpassphrase) {
    if (passphrase != repeatpassphrase)
        return false;

    if (passphrase.indexOf('\'') >= 0 || passphrase.indexOf('"') >= 0 || passphrase.indexOf('<') >= 0 || passphrase.indexOf('>') >= 0)
        return false;
    else
        return true;
}

function ValidateNumericValues(cost, quantity) {
    if (isNaN(parseFloat(cost)) || isNaN(parseFloat(quantity)))
        return false;
    else {
        if (parseFloat(quantity) <= 0)
            return false;
        else
            return true;
    }
}

function ConvertToFloat(input) {
    return parseFloat(input);
}

function HVDSanityCheck(input) {
    if (ConvertToFloat(input) > 1500)
        return false;
    else
        return true;
}

function MinimumSaleCheck(input) {
    if (ConvertToFloat(input) < 0.25)
        return false;
    else
        return true;
}

function QuickHTMLCheck(testString) {
    var htmlRegex = new RegExp("<([A-Za-z][A-Za-z0-9]*)\\b[^>]*>(.*?)</\\1>");
    return htmlRegex.test(testString);
}